#!C:\Programme\Python25\python.exe
# -*- coding: UTF-8 -*-
import os, sys,  subprocess
from os.path import *
from xml.dom.minidom import parse

# ***** include the biocase.lib directory in the python sys path for importing *****
#execfile('/Workspace/bps2/lib/biocase/adjustpath.py')
execfile( os.path.abspath( os.path.join( os.path.dirname( __file__ ), os.pardir, os.pardir, 'lib', 'biocase', 'adjustpath.py' ) ))
execfile( os.path.abspath( os.path.join( os.path.dirname( __file__ ), os.pardir, os.pardir, 'lib', 'biocase', 'appinit.py' ) ))

from biocase.configtool.general import *
import simplejson as json
import biocase.configuration

archivefilename = 'natureinfo_ABCD_2.06.zip'
dsa = 'natureinfo'
action = 'list'

archivefilename = unicode(form.getvalue('archivefilename'), 'utf-8')
dsa = form.getvalue('dsa')
action = form.getvalue("action")
fromworkfolder = form.getvalue('fromworkfolder')

archivePath = join(unicode(cfg.archiveWorkLocator), dsa) + os.sep
config = archivePath + archivefilename + ".config.xml"
proc_xml = archivePath + archivefilename + ".proc"
proc_dwca = archivePath + dsa + "_DwCA_1.0.proc"
log = archivePath + archivefilename + ".log"
log_dwca = archivePath + dsa + "_DwCA_1.0.log"
dldPath =join(unicode(cfg.archiveDownloadLocator), dsa) + os.sep
faf = dldPath + archivefilename

if dsa is None:
    execfile( os.path.abspath( os.path.join( os.path.dirname( __file__ ), 'main.cgi' ) ))
    sys.exit()

print('Content-Type: text/html\n')

# Print 25 last lines of log files
if action == "showlog":
    # First, print log
    if exists(log):
        size = getsize(log)
        f = open(log)
        # Only read 4KB at the end
        f.seek(max(size-4096, 0))
        lines = f.readlines()
        # Add line that indicates finishing
        if not exists(proc_xml):
            if exists(proc_dwca):
                lines.append("XML generation ended, conversion will be started...")
            else:
                lines.append("... processing ended.")
        # Restrict output to 25 lines
        if len(lines) > 25:
            print "(continued)"
        for line in lines[-25:]:
            print line,
        f.close()
    else:		
        print("Log file not found: " + log)

# Returns true if any archive is currently being processed for the DSA
# works for both XML and DwCA
if action == "isRunning":
    running = "false"
    for fname in os.listdir(archivePath):
        if fname[-5:] == ".proc":
            running = "true"
            break;
    print(running)

# Returns true if the archive file given is currently being converted to DwCA
if action == "isDwcaRunning":
    if os.path.exists(proc_dwca):
        print "true"
    else:
        print "false"

if action == "archiveexists":
    # If the file to be checked is the DwCA, look for any dwca's in the download folder
    if archivefilename.endswith('DwCA_1.0'):
        dwca_exists = False
        l = os.listdir(dldPath)
        for fname in l:
            if fname.endswith("dwca.zip"):
                dwca_exists = True
                break;
        if dwca_exists:
            print "true"
        else:
            print "false"

    # For XML, simply check the existence of the file in download folder
    else:
        if os.path.exists(faf):
            print("true")
        else:
            print("false")

if action == "list":
    ret = {}
    dwca_running = os.path.exists(proc_dwca)

    # First, browse the download folder
    # do not include DwCAs if there is currently a DwCA creation running!
    l = os.listdir(dldPath)
    for fname in l:
        if fname.endswith("dwca.zip"):
            if not dwca_running:
                ret[fname] = 'dwca'
        elif fname.endswith(".zip"):
            # XML archive: load namespace from config file
            try:
                dom = parse(dldPath + fname + ".config.xml")
                ns = str(dom.getElementsByTagName("schemans")[0].firstChild.data)
                ret[fname] = 'xml:' + ns
            except:
                # In version 3.0/3.1 the config/log file was stored in the working dir
                # simply ignore these, the user will have to recreate them
                pass

    # Then, check for proc files
    l = os.listdir(archivePath)
    for fname in l:
        if fname.endswith('.proc'):
            fname_head = splitext(fname)[0]
            if fname == split(proc_dwca)[1]:
                ret[fname_head] = 'proc:dwca'
            else:
                ret[fname_head] = 'proc:xml'

    # Last, log files of aborted runs
    l = os.listdir(archivePath)
    for fname in l:
        if fname.endswith('.log'):
            fname_head = splitext(fname)[0]
            addit = False

            # Ignore empty files
            if getsize(join(archivePath, fname)) > 0:
                if exists(join(dldPath, fname)):
                    # Same file exists in download folder: Only list if it's not the same file
                    a = os.stat(join(archivePath, fname))
                    d = os.stat(join(dldPath, fname))
                    if (a.st_size != d.st_size) or (d.st_mtime - a.st_mtime > 5):
                        addit = True
                else:
                    # Doesn't exist in download folder: add to list
                    addit = True

            # Check if it's running: don't add
            if fname_head in ret:
                if ret[fname_head].startswith('proc:'):
                    addit = False

            # Add * to name in order not to overwrite the finished entry
            if addit:
                ret['*' + fname_head] = 'log'

    # Return dictionary as JSON
    print json.dumps(ret)

if action == "remove":
    try:
        # If failed logs are to be removed: easy
        if fromworkfolder == 'true':
            if archivefilename.endswith('dwca.zip'):
                os.remove(log_dwca)
            else:
                os.remove(log)
            print "Log file was removed"

        else:
            # First, remove archive file from download folder
            if exists(faf):
                os.remove(faf)
                print unicode.encode(archivefilename + " was removed.", 'utf-8')
            else:
                print unicode.encode(archivefilename + " does not exist.", 'utf-8')

            # Set logfile name
            if archivefilename.endswith('dwca.zip'):
                dwnldLog = join(dldPath, dsa + "_DwCA_1.0.log")
                archiveLog = log_dwca
            else:
                dwnldLog = join(dldPath, archivefilename + '.log')
                archiveLog = log
                # and remove config file
                dwnldCfg = join(dldPath, archivefilename + '.config.xml')
                if exists(dwnldCfg):
                    os.remove(dwnldCfg)

            # Delete log from download and archive folder
            if exists(dwnldLog):
                os.remove(dwnldLog)
            if exists(archiveLog):
                os.remove(archiveLog)

    except Exception, err:
        print err
